# javascript 学习总结

## 基础
* 输入`prompt(...)`
* 比较
  * 如果两边任意一边出现 `true` 或者 `false` 使用 ===
  * 如果两边任意一边可能是特定值`0,"", []` 使用 ===
  * 剩下的所有情况，使用 ==
  * 对于引用类型来说，比较仅仅是比较其引用是否是同一个，另外在和字符串比较时，数组会自动转成字符串
  ```js
  var a = [1,2,3]
  var b = [1,2,3]
  var c = "1,2,3"
  console.log(a == b) // false
  console.log(a == c) // true
  console.log(b == c) // true
  ```
  * switch语句
  ```js
  switch(a) {
    case 2:
    case 10:
      // 2 或者 10 执行
      break;
    default:
      // 条件都不满足默认执行
  }
  ``` 

## ES6
* let 尽量将变量声明放在代码块开始，避免在(Temproal Dead Zone, TDZ)临时死亡区使用而报错
  * 尽量使用for...let，在每次循环中都会声明一个新的变量，生成了一个闭包。避免for里边的函数在调用的时候引用不到正确的变量。
* const声明，相对于保护其中的内容更注重其语意所带来的规范性
* 如果把方法定义在{}内，那么在块外执行会报ReferenceError
* spread/rest`...`放在数组前用于展开数组，放在变量前就是收集变量到一个数组里，例如 `function a(...arg){} a(a,b,c) -> arg = [a,b,c]`